/*
MAX038 Generator
 
 */

 
#include <LiquidCrystal.h>
#include <math.h>
#include <SPI.h>
#include <FreqCounter.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(4, 10, 9, 8, 7, 6);

int button1_pin = 2;
int button2_pin = 3;
int range = 1;
int old_range = 1;
int func_mode = 1;
int func_mode_mem = 1;
int func = 0;
int curr_value = 0;
int acc_value = 0;
int amp_word = 0;
int amplitude = 0;
double amp;
int offset_word = 0;
int offset = 0;
double offs;

volatile unsigned long last_millis = 0;
unsigned long frq;

byte pulse[8] = {
	0b00000,
	0b01110,
	0b01010,
	0b01010,
	0b01010,
	0b01010,
	0b11011,
	0b00000
};

byte saw[8] = {
	0b00000,
	0b00000,
	0b00001,
	0b00011,
	0b00101,
	0b01001,
	0b10001,
	0b00000
};

byte sine[8] = {
	0b00000,
	0b00000,
	0b01000,
	0b10100,
	0b10101,
	0b00101,
	0b00010,
	0b00000
};


void setup()  { 
//  Serial.begin(57600);
  pinMode(button1_pin, INPUT); 
  pinMode(button2_pin, INPUT); 
  pinMode(A2, INPUT); 
  pinMode(A3, OUTPUT);  
  pinMode(A4, OUTPUT);   
  pinMode(A5, OUTPUT); 
 
  pinMode(0, OUTPUT);   
  pinMode(1, OUTPUT);
  
  interrupts();
  attachInterrupt(0, button1_pressed, RISING);
  attachInterrupt(1, button2_pressed, RISING);
  
  digitalWrite(0, HIGH);
  digitalWrite(1, LOW); 
  
  digitalWrite(A3, LOW);
  digitalWrite(A4, LOW); 
  digitalWrite(A5, LOW);
  

 lcd.createChar(1, pulse);
 lcd.createChar(2, saw);
 lcd.createChar(3, sine);
     // set up the LCD's number of columns and rows:
 lcd.begin(16, 2);
 lcd.setCursor(0, 0);  
 lcd.print("SIGNAL GENERATOR");
 delay(3000);
} 


void loop()  {  
  if (range != old_range)
  {  
  switch (range) {            
             case 1: 
                  digitalWrite(A3, LOW);
                  digitalWrite(A4, LOW); 
                  digitalWrite(A5, LOW);
               break;             
             case 2:
                  digitalWrite(A3, HIGH);
                  digitalWrite(A4, LOW); 
                  digitalWrite(A5, LOW);
               break;  
             case 3:
                  digitalWrite(A3, LOW);
                  digitalWrite(A4, HIGH); 
                  digitalWrite(A5, LOW);
               break;  
             case 4:
                  digitalWrite(A3, HIGH);
                  digitalWrite(A4, HIGH); 
                  digitalWrite(A5, LOW);
               break;             
             case 5:
                  digitalWrite(A3, LOW);
                  digitalWrite(A4, LOW); 
                  digitalWrite(A5, HIGH);
               break;  
             case 6:
                  digitalWrite(A3, HIGH);
                  digitalWrite(A4, LOW); 
                  digitalWrite(A5, HIGH);
               break;             
             case 7:
                  digitalWrite(A3, LOW);
                  digitalWrite(A4, HIGH); 
                  digitalWrite(A5, HIGH);
               break;             
             case 8:
                  digitalWrite(A3, HIGH);
                  digitalWrite(A4, HIGH); 
                  digitalWrite(A5, HIGH);
               break;              
          }
  }    
   old_range = range;
   
   func_mode_select(); 
   
     // wait if any serial is going on
   FreqCounter::f_comp = 10;   // Cal Value / Calibrate with professional Freq Counter
   FreqCounter::start(1000);  // 1000 ms Gate Time
    while (FreqCounter::f_ready == 0) 
           frq=FreqCounter::f_freq; 
           
   // Amplitude measurement
           amp_word = analogRead(A1);
           amp = 1.17009 * amp_word + 12;
           amplitude = int(amp);           
   // Offset measurement
           offset_word = analogRead(A0);
           offs = (4.873*offset_word-110)*2.01 - 4780;
           offset = int(offs);    
           
           lcd.clear();
           lcd.setCursor(0, 0);
           lcd.print("F=");           
           lcd.print(frq);
           lcd.setCursor(10, 0);
           lcd.print("R");  
           lcd.print(range);
           lcd.setCursor(0, 1);
           lcd.print("A=");  
           lcd.print(amplitude);
           lcd.setCursor(8, 1);
           lcd.print("O=");  
           lcd.print(offset);
           lcd.setCursor(15, 1);

     switch (func_mode) {            
             case 1: 
//                    digitalWrite(0, HIGH);
//                    digitalWrite(1, LOW);
           lcd.write(2);  
               break; 
             case 2: 
//                    digitalWrite(0, LOW);
//                    digitalWrite(1, LOW); 
           lcd.write(1);  
               break; 
             case 3: 
//                    digitalWrite(0, LOW);
//                    digitalWrite(1, HIGH); 
           lcd.write(3);  
               break;                 
                        }          
        
           delay(200);
 }


  void button1_pressed() {
  long current_Time = millis();  
  if ((current_Time - last_millis) > 150) {
  last_millis = current_Time; 
  
  if (range == 8)   {
    range = 1; 
   }   
  else {
    range = ++range;   
   } 
  }
 }     
 
 void button2_pressed() {
  long current_Time = millis();  
  if ((current_Time - last_millis) > 150) {
  last_millis = current_Time; 
  
  if (range == 1)   {
    range = 8; 
   }   
  else {
    range = --range;   
   } 
  }
 }  
 
  void func_mode_select() {    
  acc_value = 0; 
  for (int i=0; i <= 7; i++){
  curr_value = analogRead(A2);   
  acc_value = acc_value + curr_value; 
  }      
  func =  int(acc_value/8); 
  func_mode_mem = func_mode;
  if (func>=680)               func_mode=1;
  if ((func>=340)&&(func<680)) func_mode=2;
  if (func<340)                func_mode=3;
  
  if (func_mode_mem != func_mode) {
     switch (func_mode) {            
             case 1: 
                    digitalWrite(0, HIGH);
                    digitalWrite(1, LOW); 
               break; 
             case 2: 
                    digitalWrite(0, LOW);
                    digitalWrite(1, LOW); 
               break; 
             case 3: 
                    digitalWrite(0, LOW);
                    digitalWrite(1, HIGH); 
               break;                 
                        }
                                 }  
                            }
